﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace MVC09NewSample.Controllers
{
    public class GanttController : Controller
    {
        //
        // GET: /Gantt/

        public ActionResult Index()
        {
            var DataSource = GanttDefaultData.GetData();
            ViewBag.datasource = DataSource;
            ViewBag.resource = ResourceList.GetResources();
            return View();
        }

        public class Resource
        {
            public int ResourceId { get; set; }
            public string ResourceName { get; set; }

        }

        //...
        public class ResourceList
        {
            public static List<Resource> GetResources()
            {
                List<Resource> ResourceCollection = new List<Resource>();
                ResourceCollection.Add(new Resource() { ResourceId = 1, ResourceName = "Project Manager" });
                ResourceCollection.Add(new Resource() { ResourceId = 2, ResourceName = "Software Analyst" });
                ResourceCollection.Add(new Resource() { ResourceId = 3, ResourceName = "Developer" });
                ResourceCollection.Add(new Resource() { ResourceId = 4, ResourceName = "Testing Engineer" });
                return ResourceCollection;
            }

        }

        public class DefaultData
        {
            public string StartDate { get; set; }
            public string BaselineStartDate { get; set; }
            public string BaselineEndDate { get; set; }

            public int Id { get; set; }
            public string Name { get; set; }
            public int Duration { get; set; }
            public int PercentDone { get; set; }
            public List<object> ResourceId { get; set; }
            public List<DefaultData> Children { get; set; }
            public string Predescessor { get; set; }
            public string Desc { get; set; }
        }


        public class GanttDefaultData
        {
            public static List<DefaultData> GetData()
            {
                List<DefaultData> list = new List<DefaultData>();
                list.Add(new DefaultData()
                {
                    Id = 1,
                    Name = "Task 1",
                    StartDate = "10/16/2013",
                    Duration = 10,
                    PercentDone = 70,
                    Desc = "Product 1",
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 2,
                            Name = "Child task 1",
                            StartDate = "10/16/2013",
                            Duration = 4,
                            PercentDone = 80,
                            Desc = "Material 1",
                        },
                        new DefaultData()
                        {
                            Id = 3,
                            Name = "Child Task 2",
                            StartDate = "10/17/2013",
                            Duration = 5,
                            PercentDone = 65,
                            Desc = "Material 2",
                            Predescessor = "2"
                        },
                       
                    })

                });

                list.Add(new DefaultData()
                {
                    Id = 4,
                    Name = "Child task 3",
                    StartDate = "10/21/2013",
                    Duration = 6,
                    PercentDone = 77,
                    Desc = "Product 2",
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                                    Id = 5,
                                    Name = "Grand child task 1",
                                    StartDate = "10/21/2013",
                                    Duration = 3,
                                    PercentDone = 60,
                                    Desc = "Material 1",
                                    Predescessor = "2"
                        },
                        new DefaultData()
                        {
                                    Id = 6,
                                    Name = "Grand child task 2",
                                    StartDate = "10/22/2013",
                                    Duration = 2,
                                    PercentDone = 77,
                                    Desc = "Material 2",
                                    Predescessor = "5"
                        },
                        new DefaultData()
                        {
                                    Id = 7,
                                    Name = "Grand child task 3",
                                    StartDate = "10/23/2013",
                                    Duration = 0,
                                    PercentDone = 0,
                                    Desc = "Material 3",
                                    Predescessor = "6"
                        },
                        
                    })

                });
               
                return list;
            }
        }


    }
}
